<?php
/*<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : beans des recettes    -->
<!-- VERSION    : 1.0                   -->
<!-- VERS. DATE : 25.02.2022            -->
<!-- CREA. DATE : 25.02.2022            -->
<!---------------------------------------->*/ 

class Recipe implements JsonSerializable {

    private $pk_recipe;
    private $name;
    private $description;
    private $image;
    private $fk_user;
    private $ingredients;
    private $steps;

    public function __construct($pk_recipe, $name, $image, $description, $fk_user, $steps, $ingredients) {
        $this->pk_recipe = $pk_recipe;
        $this->name = $name;
        $this->description = $description;
        $this->image = $image;
        $this->fk_user = $fk_user;
        $this->ingredients = $ingredients;
        $this->steps = $steps;
    }

    public function getName() {
        return $this->name; 
    }

    public function getPK_Recipe() {
        return $this->pk_recipe; 
    }

    public function getDescription() {
        return $this->description; 
    }

    public function getImage() {
        return $this->image; 
    }

    public function getFK_User() {
        return $this->fk_user; 
    }

    public function getIngredients() {
        return $this->ingredients; 
    }

    public function getSteps() {
        return $this->steps; 
    }


    //FAIRE LES SETTERS
    public function setIngredients($ingredients) {
        $this->ingredients = $ingredients; 
    }
    //FAIRE LES SETTERS
    //FAIRE LES SETTERS
    //FAIRE LES SETTERS
    //FAIRE LES SETTERS
    //FAIRE LES SETTERS
    //FAIRE LES SETTERS
    public function jsonSerialize()
    {
        return 
            [
                'pk'   => $this->getPK_Recipe(),
                'nom' => $this->getName(),
                'img' => $this->getImage(),
                'fk_user' => $this->getFK_User(),
                'description' => $this->getDescription(),
                'ingredients' => $this->getIngredients(),
                'steps' => $this->getSteps()
            ];
    }
}



?>