
<?php 
/*
    <!---------------------------------------->
    <!-- AUTHOR     : DIAS MADEIRA LUCA     -->
    <!-- DESC       : manager des users    -->
    <!-- VERSION    : 1.2                   -->
    <!-- VERS. DATE : 10.03.2022            -->
    <!-- CREA. DATE : 18.02.2022            -->
    <!---------------------------------------->
*/
	include_once('../wrk/UserDBManager.php');
    include_once('./SessionManager.php');

    $sessionManager = new SessionManager();

    if (isset($_SERVER['REQUEST_METHOD']))
	{
		switch ($_SERVER['REQUEST_METHOD'])
		{
			case 'GET':
                
                if( isset($_GET['pk_user']) ) {

                    //OBTENTION D'UN AUTRE USER
                    $wrkDB = new userDBManager();

                    $result = $wrkDB->getUser($_GET['pk_user']);

                    if($result == 'invalid ID') {
                        http_response_code(404);
                        echo json_encode(array('message' => 'INVALID ID'));
                    } else if ($result != false) {
                        http_response_code(200);
                        echo $result;
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }

                } else if ($sessionManager->isConnected()) {

                    //obtenir son propre user
                    $wrkDB = new userDBManager();

                    $result = $wrkDB->getUser($sessionManager->getCurrentUser());


                    if($result == 'invalid ID') {
                        http_response_code(404);
                        echo json_encode(array('message' => 'INVALID SESSION'));
                    } else if ($result != false) {
                        http_response_code(200);
                        echo $result;
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }





                } else {
                    http_response_code(400);
                    echo 'bad request';
                }
			break;

            case 'POST':
                if(isset($_POST['name']) && isset($_POST['email']) && isset($_POST['password']) ) {

                    //AJOUT D'UN USER
                    $wrkDB = new userDBManager();

                    $result = $wrkDB->addUser($_POST['name'], $_POST['email'], $_POST['password']);


                    
                    if($result == 'email or username already taken') {
                        http_response_code(400);
                        echo json_encode(array('message' => 'email or username already taken'));
                    } else if ($result != false) {
                        //OUVRIR SESSION
                        $sessionManager->openSession($result);
                        http_response_code(200);
                        //echo '';
                    } else {
                        http_response_code(500);
                        echo json_encode(array('message' => 'ERROR'));
                    }

                } else if(isset($_POST['action']) && $sessionManager->isConnected()) {

                    if($sessionManager->destroySession()) {
                        http_response_code(200);
                        //echo '';
                    } else {
                        http_response_code(500);
                        echo 'tried to destroy a non-existant session';
                    }


                } else {
                    http_response_code(500);
                    echo 'bad request';
                }
            break;

            case 'PUT':
                parse_str(file_get_content("php://input", $vars));
                
                $sessionCtrl = new SessionManager();

                //'pk=' + this.pk + '&description=' + description + '&image=' + avatarPath;
                $pk_user_sent = $vars['pk'];
                $pk_user_of_session = $sessionCtrl->currentUser();
                $description = $vars['description'];
                $image = $vars['image'];
                
                
                if(false/*?????????????*/) {

                } else {
                    http_response_code();
                    echo '';
                }
            break;
		}
	}
?>