//<!---------------------------------------->
//<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
//<!-- DESC       : ctrl de l'connexion -->
//<!-- VERSION    : 1.0                   -->
//<!-- VERS. DATE : 11.03.2022            -->
//<!-- CREA. DATE : 11.03.2022            -->
//<!---------------------------------------->

$(document).ready(function () {
    
    
    //creation classe contrôle
    ctrl = new Ctrl(connexionSuccess, connexionError);

    //charger script demande
    $.getScript("javascript/service/serviceHTTP.js", function() {
        console.log("serviceHTTP.js charge !");
    });



});

class Ctrl {
    constructor(connexionOK, connexionNOK) {
        this.connexionOK = connexionOK;
        this.connexionNOK = connexionNOK;
    }

    connexion() {
        let username = $('#CONSCRIPTION_USERNAME').val();
        let password = $('#CONSCRIPTION_PASSWORD').val();
        let params = 'action=checkLogin&Username=' + username + '&Password=' + password;
        postRequest(params, this.connexionOK, this.connexionNOK, 'loginManager.php');
    }
}

function connexionSuccess(data, text, jqXHR) {
    sessionStorage.setItem('logged', data);
    console.log(data);
    window.location.href = "./Recettes.html";
}

function connexionError(request, status, error) {
    alert('information erronés, ou compte inexistant.');
    //AFFICHER MESSAGE D'ERREUR
    console.log(error);
    console.log(status);

}