<?php 
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : manager des sessions  -->
<!-- VERSION    : 1.2                   -->
<!-- VERS. DATE : 11.03.2022            -->
<!-- CREA. DATE : 10.03.2022            -->
<!---------------------------------------->
*/

class SessionManager {

    public function __construct() {
        session_start();
    }

    public function destroySession() {
        return session_destroy();
    }

    public function openSession($pk_user) {
        $_SESSION['logged'] = $pk_user;
    }

    public function isConnected() {
        return isset($_SESSION['logged']);
    }

    public function getCurrentUser() {
        return $_SESSION['logged'];
    }
}

?>