<?php 
/*
<!---------------------------------------->
<!-- AUTHOR     : DIAS MADEIRA LUCA     -->
<!-- DESC       : manager des logins    -->
<!-- VERSION    : 1.0                   -->
<!-- VERS. DATE : 18.02.2022            -->
<!-- CREA. DATE : 18.02.2022            -->
<!---------------------------------------->
*/
	include_once('../wrk/LoginDBManager.php');
    include_once('./SessionManager.php');
    $sessionCtrl = new SessionManager();
    if (isset($_SERVER['REQUEST_METHOD']))
	{
		switch ($_SERVER['REQUEST_METHOD'])
		{
			case 'POST':
				if (isset($_POST['action'])) {
                    switch($_POST['action']) {
                        case 'checkLogin':
                            if(isset($_POST['Username']) && isset($_POST['Password'])) {
                                
                                //récupération du pk_user dans la DB en vérifiant le Username
                                $wrkDB = new loginDBManager();
                                $pk_user = $wrkDB->checkLogin($_POST['Username'], $_POST['Password']);

                                //si valide continuer, sinon envoyer message d'erreur
                                if($pk_user != 'INCORRECT_LOGIN') {

                                    //ouvrir une session et y mettre la pk du user
                                    
                                    $sessionCtrl->openSession($pk_user);

                                    //envoyer message de réussite, si réussi
                                    if($sessionCtrl->isConnected()) {
                                        http_response_code(200);
                                        echo 'login valide, bienvenue.';
                                        echo $sessionCtrl->getCurrentUser();
                                    } else {
                                        http_response_code(503);
                                        echo 'erreur dans la création de session.';
                                    }
                                } else {
                                    http_response_code(403);
                                    echo 'login invalide, utilisateur ou mot de passe erroné';
                                }
                            } else {
                                http_response_code(404);
                                echo 'Paramètre Username ou Password manquant';
                            }
                        break;

                        case 'disconnect' :
                            //création session manager
                            

                            //vérification de si la session existe
                            if ($sessionCtrl->isConnected()) {
                                //destruction de la session
                                if ($sessionCtrl->destroySession()) {
                                    http_response_code(200);
                                    echo "session détruite avec succès";
                                } else {
                                    http_response_code(503);
                                    echo "erreur dans la destruction de la session";
                                }
                            } else {
                                http_response_code(401);
                                echo "erreur, la session n'existe pas.";
                            }
                        break;
                    }
				} else {
                    http_response_code(404);
					echo 'Paramètre action manquant';
				}
				break;
		}
	}
?>